const fs     = require('fs');
const util   = require('util');
const events = require('events');
/**
 * InputEvent
 */
function InputEvent(device, options){
  events.EventEmitter.call(this);
  this.device  = device;
  this.options = options || { flags: 'r', encoding: null };
  this.fd = fs.createReadStream(this.device, this.options);
  this.fd.on('data', this.process.bind(this));
}
/**
 * [inherits EventEmitter]
 */
util.inherits(InputEvent, events.EventEmitter);

/**
 * [function parse]
 * @param  {[type]} buf [description]
 * @return {[type]}     [description]
 */
InputEvent.prototype.parse = function(buf){
  return {
    tssec:   buf.readUInt32LE(0),
    tsusec:  buf.readUInt32LE(4),
    type:    buf.readUInt16LE(8),
    code:    buf.readUInt16LE(10),
    value:   buf.readUInt32LE(12)
  };
};
/**
 * [function description]
 * @param  {[type]} data [description]
 * @return {[type]}      [description]
 */
InputEvent.prototype.process = function(data){
  var ev = this.parse(data);
  this.emit('data', ev);
};
/**
 * [exports InputEvent]
 * @type {[type]}
 */
module.exports = InputEvent;
